Proof Complexity and the KneserLovász Theorem (I)
Abstract
We investigate the proof complexity of a class of propositional formulas expressing a combinatorial principle known as the KneserLovász Theorem. This is a family of propositional tautologies, indexed by an nonnegative integer parameter that generalizes the Pigeonhole Principle (obtained for ).
We show, for all fixed , lower bounds on resolution complexity and exponential lower bounds for bounded depth Frege proofs. These results hold even for the more restricted class of formulas encoding Schrijver’s strenghtening of the KneserLovász Theorem. On the other hand for the cases (for which combinatorial proofs of the KneserLovász Theorem are known) we give polynomial size Frege (), respectively extended Frege () proofs. The paper concludes with a brief announcement of the results (presented in subsequent work) on the complexity of the general case of the KneserLovász theorem.
1 Introduction
One of the most interesting approaches in discrete mathematics is the use of topological methods to prove results having a purely combinatorial nature. The approach started with Lovász’s proof [Lov78] of a combinatorial statement raised as an open problem by Kneser in 1955 (see [dL04] for a historical account). A significant amount of work has resulted from this conjecture (to get a feel for the advances consult [Mat08, Koz08]).
Methods from topological combinatorics raise interesting challenges from a complexitytheoretic point of view: they are nonconstructive, often based on principles that appear to lack polynomial time algorithms (e.g. Sperner’s Lemma and the BorsukUlam Theorem [Pap94]). The concepts involved (simplicial complexes, chains, chain maps) seem to require intrinsically exponential size representations.
In this paper we raise the possibility of using statements from topological combinatorics as a source of interesting candidates for proof complexity. In particular we view the KneserLovász theorem as a statement on the unsatisfiability of a certain class of propositional formulas, and investigate the complexity of proving their unsatisfiability.
We were initially motivated by the problem of separating the Frege and extended Frege proof systems. Various candidate formulas have been proposed (see [BBP95] for a discussion). It was natural to wonder whether the nonelementary nature of mathematical proofs of Kneser’s theorem translates into hardness and separation results in propositional complexity. We no longer believe that this problem provides such examples. Yet gauging its precise complexity is still, we feel, interesting.
A slightly different perspective on this problem is the following: Matoušek obtained [Mat04] a ”purely combinatorial” proof of the KneserLovász theorem, a proof that does not explicitly mention any topological concept. While combinatorial, Matoušek’s proof is nonconstructive: the approach in [Mat04] ”hides” in purely combinatorial terms the application of the socalled Octahedral Tucker Lemma, a discrete variant of the BorsukUlam theorem. Searching for the object guaranteed to exist by this principle, though ”constructive” in theory [FT81] is likely to be intractable, as the associated search problem for the 2d Tucker lemma^{2}^{2}2As kindly pointed to us by professor Pálvőlgyi this is also likely but not explicitly proved in [Pál09] for the octahedral Tucker lemma. is complete for the class PPAD [Pál09].
Thus another perspective on the main question we are interested in is under what circumstances do cases of the KneserLovász theorem have combinatorial proofs of polynomial size. This depends, of course, on the proof system considered, making the question fit the ”bounded reverse mathematics” program of Cook and Nguyen [CN10]. A natural boundary seems to be the class of Frege proofs: for the KneserLovász theorem is equivalent to the pigeonhole principle (PHP) that has polynomial size Frege proofs, but exponential lower bounds in resolution [Bus87] and bounded depth Frege. On the other hand obtaining a similar upper bound for the general case would be quite significant, as it would seem to require completely bypassing the techniques from Algebraic Topology starting instead from radically different principles.
Our contributions (and the outline of the paper) can be summarized as follows: In Section 3 we give a reduction between and for arbitrary . As an application we infer that existing lower bounds for PHP apply to formulas for any fixed value of . In Section 4 we investigate cases (when the KneserLovász theorem has combinatorial proofs). We give Frege proofs (for ) and extended Frege proofs (for ), both having polynomial size.
As usual in the case of bounded reverse mathematics, our positive results could have been made uniform by stating them (more carefully) as expressibility results in certain logics: for instance our result for the case of the KneserLovász theorem could be strengthened to an expressibility result in logical theory [CN10]. We will not pursue this approach in the paper, deferring it to the journal version.
2 Preliminaries
Throughout this paper will be a fixed constant greater or equal to 1. Given a set of integers , we will denote by the set of cardinality subsets of set . We will write instead of in the previous definition in case for some . will be called stable if for no both and are in . Also denote by (called ”firsts of A”) the set of smallest (at most) elements of .
The KneserLovász theorem is formally stated as follows:
Proposition 1.
Given and a function there exist two disjoint sets and a color with .
An even stronger form was proved by Schrijver [Sch78]: Proposition 1 is true if we limit the domain of to all stable subsets^{3}^{3}3we will denote this collection of sets by of of cardinality :
Proposition 2.
Given and a function there exist two disjoint sets and a color with .
The KneserLovász Theorem can be seen as a statement about the chromatic number of a particular graph: define the graph to consist of the subsets of cardinality of , connected by an edge when the corresponding sets are disjoint (Figure 1). Then the KneserLovász Theorem is equivalent to (in fact , since the upper bound is easy [Mat08]).
We assume familiarity with the basics of proof complexity, as presented for instance in [Kra95], in particular with resolution complexity (the size measure will be denoted by ), Frege, extended Frege (EF) proofs and the concepts and results in [Bus87]. We will state our positive results using the sequent calculus system LK [Kra95], a system equivalent to Frege proofs.
Definition 1.
Let be the formula
has polynomial time Frege proofs [Bus87]. An important ingredient of the proof is the representation of natural numbers as sequences of bits, with every bit being expressed as the truth value of a certain formula. We will use a similar strategy. In particular quantities such as will refer to the logical encoding of the binary expansion of integer . We will further identify statements such as ”” or ”” with the logical formulas expressing them. The approach of Buss uses counting, defining a set of families of formulas , such that yields the binary encoding of the number of variables that are TRUE. We will often drop the index from notation if its value is selfevident. We will further need several simple intentional properties of function with respect to combinatorics. Formal arguments are deferred to the journal version.
Lemma 1.
Let . and let be logical variables . In one can give polynomialsize proofs of the following facts:

.

Let be logical variables. Then

Let be logical variables. Then

Finally a variable substitution in a formula will refer in this paper to substituting every variable by some other variable (not necessarily in a 11 manner).
2.1 Propositional formulation of the KneserLovász Theorem
We define a variable for every set of cardinality , and partition class . is intended to be TRUE iff and zero otherwise.
Definition 2.
Denote by

the formula .

the formula .

the formula

Finally, denote by the formula . is (by [Lov78]) a tautology with variables.

We will also encode the onto version of the KneserLovász Theorem. Indeed, denote by the formula
Note that formula is essentially the Pigeonhole principle .
3 Lower bounds: Resolution Complexity and boundeddepth Frege proofs
The following result shows that many lower bounds on the complexity of the pigeonhole principle apply directly to any family :
Theorem 1.
For all there exists a variable substitution
,
such that is a formula consisting precisely of the clauses of
(perhaps repeated and in a different order).
Proof.
For simplicity we will use different notations for the sets of variables of the two formulas: we assume that and , with obvious (different) ranges for and .
Let . For define by:

Case 1: : Define
(1) 
Case 2::
In this case necessarily both and are members of .
Let , . Let . Define
(2)
Formula has clauses of two types

(a). Clauses of type , with .

(b). Clauses of type with , .
As preserves the second index, every clause of type (a) of maps via to a clause of type (a) of . On the other hand every clause of type (a) is the image through of some clause of , for instance of clause , where .
As for clause of type (b), again we use the fact that preserves the second index, and prove that the substituted variables correspond to disjoint subsets:

Case I: both fall in Case 1. of the definition of .
Denote for simplicity , hence ).
It follows that are disjoint (as and , ). Note that the converse is also true: every clause is the image of clause , with , .

Case II: One of the sets, say , falls under Case 2, the other one, , falls under Case 1 (note that and cannot both fall under Case 2, as they would both contain and they would no longer be disjoint). In this case As and , Therefore, even though it might be possible that , certainly (since there are no elements in larger than ). Thus .
∎
∎
The previous result can be applied times to show the following two lower bounds:
Theorem 2.
For any fixed we have (where the constant might depend on ).
Proof.
The result follows from the following simple
Lemma 2.
Let be a propositional formula let be a variable substitution and let be the resulting formula. Assume that is a resolution refutation of and let . Then is a resolution refutation of . Consequently .
Proof.
Similar, more powerful (less trivial) results of this type were explicitly stated, e.g. in [BSN11]. ∎
∎
∎
∎
Similarly
Theorem 3.
For any fixed and arbitrary there exists such that the family has depth Frege proofs
Proof.
We employ the the corresponding bound for [KPW95]. ∎
∎
3.1 Extension: lower bounds on the proof complexity of Schrijver’s theorem
We can prove (stronger) bounds similar to those of Theorems 2 and 3 for Schrijver’s formulas by noting that the following variant of Theorem 1 holds:
Theorem 4.
For every there exists a variable substitution , such that is a formula consisting precisely of the clauses of (perhaps repeated and in a different order).
Proof.
Substitution is exactly the same as the one in the proof of Theorem 1. In this case we need to further argue three things:

If maps onto and is stable then so is .

Every clause of is the image of a clause with stable.

Every clause of is the image of a clause with disjoint and stable.

If then satisfies the stability condition everywhere except perhaps at elements 1 and n2. But if then (as is stable). Similarly . This contradicts the fact that must contain one of .
On the other hand it is not possible that falls under Case 2, as it would have to contain successive elements .

Since is stable, one of is not in . Define to consist of together with the unique element in not forbidden by stability.

Similarly to (2): given disjoint stable sets , in obtain and by adding the elements to , one to each set, respecting the stability condition. This is possible as and are disjoint. For instance, if then , and we distribute in and in .
∎
∎
4 The cases and of the KneserLovász Theorem
Unlike the general case, for Kneser’s conjecture has combinatorial proofs [Sta76],[GJ76]. This facts motivates the following theorem, similar to the one proved in [Bus87] for the Pigeonhole Principle:
Theorem 5.
The following are true:

(a) The class of formulas has polynomial size Frege proofs.

(b) The class of formulas has polynomial size extended Frege proofs.
Proof.
Informally, the basis for the combinatorial proofs in [GJ76], [Sta76] of cases is the following claim, only valid for these values of : any partition of into classes contains at least one class such that either .
This claim could be used as the basis for the propositional simulation of the proofs from [Sta76] and [GJ76], respectively. This strategy only leads to extended Frege, rather than Frege proofs for . The reason is that we eliminate one element from and one class from the partition. Similar to the case of PHP in [Bus87], doing so involves renaming, leading to extended Frege proofs.
For we will bypass the problem above by giving a stronger, countingbased proof of . We will then explain why a similar strategy apparently does not work for as well. In both situations, below we first present the mathematical argument, then discuss how to formalize it in (extended) Frege.
4.1 Case
Mathematical (semantic) proof.
The result follows from the following sequence of claims:
Lemma 3.
Given any (n3)coloring of and color , at least one of the following alternatives is true:

there exist two disjoint sets .

.

there exists , .
Proof.
Assume that and there is a set , , then either or , for some . If then there exists another set with . has to intersect both and , thus . Hence . ∎
∎
Define, for
(call such an counted by special)
Lemma 4.
Sequences are monotonically increasing.
Proof.
First . Next . Finally, if , if . In this latter case hence ∎
∎
We now prove the following result:
Lemma 5.
For , .
Proof.
First . Indeed, the left hand side is
and similarly for the righthand side. The desired inequality follows from the fact that , valid since a special may be counted for two different .
We prove the lemma by showing the stronger inequality
(3) 
The first two terms of the righthand side of (3) count sets with at least one special element. Indeed is the number of pairs with and special. This formula overcounts sets with at least one special element when is special too (and set is counted for both pairs and ). The number of such pairs is precisely .
Now sums up cardinalities of color classes to . For those ’s in such that and all sets in the color class intersects at a special , all these sets contain a special value, hence they are also counted by the righthand side of (3). The difference is made by the remaining ’s (there are of them). By Claim 3 they add at most sets to , establishing the desired result. ∎
∎
Lemma 6.
We have .
Proof.
. But hence
∎
∎
Now Theorem (5) (a) follows by setting . The righthand side is . But there are sets to cover. ∎
∎
Propositional simulation.
Now we start translating the above proof into sequent calculus LK. We will sketch the nontrivial steps of the translation. Tedious but straightforward computations shows that all these steps amount to polynomial length proofs.
Lemma 3 can, for instance, be polynomially simulated as follows:
Lemma 7.
For and define the propositional formula
to be
Here are Buss’s counting formulas. Then for every formula has proofs of polynomial length in sequent calculus LK.
Proof.
We will apply the following trivial
Lemma 8.
Let be four distinct subsets of cardinality 2 of [n]. Then at least one of the following alternatives holds:

At least two sets among are disjoint.

and
The lemma will be used ”at the meta level”, that is it will not be codified propositionally, but simply used to argue for the correctness of the proof.
Define (only for notational convenience, not as part of the Frege proof) shorthand
Now for any
On the other hand, when two of these sets must be disjoint,
As for any any two disjoint sets in are part of a 4tuple of sets in
(4) 
Now we rewrite
Fix an arbitrary 4tuple . For any , one of the sets is disjoint from . Hence by modus ponens (cut) with and with
By repeatedly introducing ANDs in the conclusion, then OR in the antecedent
By repeated introduction of ORs in both the antecedent and the conclusion
Taking into account (4) and moving the third antecedent on the righthand side we get the proof of Lemma 7. ∎
∎
Definition 3.
Define for , formula
For let be the number of indices such that there is a color , with .
Remark 1.
Semantically we have (in we do not require that the intersection of all sets have cardinality exactly one, but that is true if )
Given we can compute, using a Frege proof, the binary representation of . as Now define for
One can easily prove in LK the following
Lemma 9.
Lemma 10.
One can compute in LK the binary expansions of , and prove that
Proof.
For the first part we use Buss’s counting approach. For the second, define
Then (one can readily prove in LK that) . Summing up we get . The proof (using the fact that the cardinal of a union of disjoint sets is the sum of cardinals of individual subsets) can easily be simulated in LK. ∎
∎
Definition 4.
Let
where

is the smallest element in , is the largest.

in the above expression is a shorthand for . Since there are sets to consider, the size of the formula after expanding to CNF is .
Lemma 11.
One can prove in LK that
Proof.
The inequality follows in the following way: From Lemma 7
Now assume . For set is among the ’s in the conjunction defining , so all these formulas evaluate to FALSE. Furthermore, if and then exactly one of the two remaining terms, and also simplifies to FALSE. Indeed, there is a set with . does not contain one of , hence appears in exactly one of the corresponding conjunctions, making it FALSE.
Hence every set counted by is among those counted by and, by , only in one such set.
∎
∎
Define
Lemma 12.
We have (and can prove in polynomial size in LK)
Proof.
The first equality amounts to no more than semantic reinterpretation. The last equality follows from Lemma 1 (2). ∎
∎